## chicken 1.22

=== doc/Makefile ===
# A very simple makefile for the creation of the manual from the LaTeX sources
# and conversion to other formats.

CHICKEN=chicken

# Usually you want this as the default.
dvi: manual.dvi

ps: manual.ps

pdf: manual.pdf

html : manual.html.gen

all: manual.dvi manual.ps manual.pdf manual.html.gen

# the first latex command creates all of the reference files for things like
# the table of contents, the second latex command remakes the manual given the
# reference files so things like the table of contents can exist in the final
# version.
manual.dvi: manual.tex
	make clean
	latex manual.tex 
	makeindex manual.idx
	latex manual.tex -interaction=batchmode
	latex manual.tex -interaction=batchmode

manual.ps: manual.tex
	make dvi
	dvips manual.dvi -o manual.ps

manual2up.ps: manual.ps
	psnup -2 $< $@

manual.pdf: manual.tex
	make dvi
	pdflatex manual.tex

manual.html.gen: manual.tex
	mkdir -p manual
	./tex2page manual
	./tex2page manual
	touch manual.html.gen

clean:
	rm -rf *.toc *.log *.dvi *.aux *.ps *.pdf *.out manual/* *.html.gen
	rm -rf *.idx *.ilg *.ind

## chicken 2.5

=== CMakeLists.txt ===
# Copyright (c) 2006 by Brandon J. Van Every under MIT-style license.
# See LICENSE section at end of file for full license text.

####################################################################
#  TUTORIAL                                                        #
####################################################################

# This is working code for building the Chicken Scheme-to-C compiler.
# It is also a tutorial for building non-trivial CMake projects.
# Please realize that the 1st mission of this code is always to
# build Chicken properly.  If a section is under-commented or under-
# explained, that's because nobody has had time to explain it.  It
# may also be deemed an unstable part of the build design, and
# thus not worthy of being documented, as it will likely change.
#
# Chicken developers: do not remove tutorial comments from the code.
# Brevity is not the goal here.  Aside from making both Chicken and
# CMake more accessible to newbies, it is important to have good
# documentation in case Brandon J. Van Every is hit by a truck.
#
# If you notice inaccuracies, inconsistencies, or ways that the 
# explanations can be improved, please report them on the
# Chicken mailing list.  You can always access the mailing list from
# the Chicken homepage:
#
#   http://www.call-with-current-continuation.org


####################################################################
#  CMAKE SPECIFIC ISSUES                                           #
####################################################################

# As this is also a tutorial for building non-trivial CMake projects,
# some words on how to utilize the CMake community.  Here are the
# basic resources:
#
#   read the docs that ship with CMake
#
#   CMake FAQ
#   http://www.cmake.org/Wiki/CMake_FAQ
#
#   CMake Useful Variables
#   http://www.cmake.org/Wiki/CMake_Useful_Variables
#   This is really important because the CMake 2.4.3 documentation
#   does not document the variables that CMake uses, and there are
#   quite a few of them.
#
#   CMake mailing list
#   http://www.cmake.org/mailman/listinfo/cmake
#   Once you've made a reasonable effort to read the docs, the FAQ,
#   and the Useful Variables, go straight to the mailing list and
#   ask questions.  The docs are terse and omit some important
#   things, like the CMake variables.  People on the mailing list
#   are very helpful and responsive.  This is the main way that
#   you'll get the best quality of support from the CMake community.
#
#   CMake mailing list archive
#   http://public.kitware.com/pipermail/cmake/
#   If you're a newbie, there's a good chance your questions have
#   been asked already.  Although people don't mind newbie questions,
#   you can often get your answers faster if you just look them up in
#   the archive.  There's no search facility on this page, so using
#   Google Advanced Search is a good idea.  Goto
#   http://www.google.com/advanced_search and for the Domain, enter
#   the URL of the mailing list archive.
#
#   CMake wiki
#   http://www.cmake.org/Wiki/CMake
#   This has tutorials and lots more info that you may find useful.
#
#   CMake Bug Tracker
#   http://www.cmake.org/Bug/
#   Use the bug tracker both to report bugs in CMake, and to make
#   Feature Requests.  You may want to discuss the bug or feature
#   request on the mailing list before making an official entry.
#   For instance, whether something is a bug or a feature request
#   may be in the realm of debate.  :-)  When filing bugs, it is
#   best to provide a trivial CMakeLists.txt that reproduces the
#   problem.  You can get help on more complicated pieces of code,
#   but if you've already isolated the problem, quick action is
#   more likely.


####################################################################
#  CMAKE VERSION                                                   #
####################################################################

# CMake undergoes rapid development.  Open source projects such as
# Chicken tend to stress CMake's capabilities, and bugs in CMake are
# frequently found.  Kitware is very good at reacting quickly to
# bugs and adding new features.  So good, that even minor releases
# can have significant differences in features available.  Do not
# expect old CMake binaries to simply work!  If your project is
# non-trivial, you are probably exploring non-trivial CMake
# capabilities somewhere, and backwards compatibility is not assured.

CMAKE_MINIMUM_REQUIRED(VERSION 2.4.3 FATAL_ERROR)

# Bugs typically show up in the current version of CMake you're using.
# Then you make a bug report to http://www.kitware.com/Bug , and
# often the bug gets fixed in the CVS repository.  Then you want to
# verify that the bug was actually fixed.  But, you want to keep
# running your old code, because the next version of CMake hasn't
# shipped and you don't expect people to be compiling CMake from CVS.
#
# To handle this, we need to know what version of CMake we're using.
# We already issue a fatal error for any CMake less than 2.4.3.
# So this is sufficient for distinguishing whether we've got
# CMake 2.4.3, or something greater.  We would ideally like to
# make lexical comparisons on CMake version numbers, and be able
# to say things like "if it's greater than version 2.x.y, do this."
# But that's work to implement, and this is easy and sufficient for now.

SET(IS_CMAKE_243 false)
IF(CMAKE_MAJOR_VERSION EQUAL 2)
  IF(CMAKE_MINOR_VERSION EQUAL 4)
    IF(CMAKE_PATCH_VERSION EQUAL 3)
      SET(IS_CMAKE_243 true)
    ENDIF(CMAKE_PATCH_VERSION EQUAL 3)
  ENDIF(CMAKE_MINOR_VERSION EQUAL 4)
ENDIF(CMAKE_MAJOR_VERSION EQUAL 2) 


####################################################################
#  CHICKEN PROJECT                                                 #
####################################################################

# All CMake projects need a name.  The name is global to all
# CMakeLists.txt in subdirectories.  Once you define a project
# named "myproject", the variable "myproject_SOURCE_DIR" exists.
# This is the toplevel source directory of your project, i.e.
# wherever your topmost CMakeLists.txt resides.
#
# You can also specify support for languages other than C, using
# additional arguments.  Chicken only needs C, so we don't bother.

PROJECT(Chicken)

# You can specify the order in which directories are searched for
# header files.  Chicken is a multi-directory project, so we do
# need to tell subdirectories where to find our toplevel *.h files.
# Also, the user may already have Chicken installed on their system.
# To avoid any possibility of picking up wrong header files from
# the system, we search our own directories BEFORE searching
# system directories.

INCLUDE_DIRECTORIES(BEFORE ${Chicken_SOURCE_DIR})


####################################################################
#  CHECKING HEADER FILES                                           #
####################################################################

# Typically we do not know if a header file, library, function, or
# other symbol is available on the system.  CMake has standard
# "modules" for checking their availability.  CMake "modules" are
# not available by default; if we want them, we have to explicitly
# INCLUDE them.
#
# CheckIncludeFile and CheckIncludeFiles do not do quite the same thing.
# CheckIncludeFile is the simpler case, when you only need 1 *.h file
# and it can be compiled in a straightforward manner into a trivial
# C test program.  Sometimes, however, multiple *.h files must be
# included together, in a specific sequence, and cannot be tested in
# isolation from one another.  Such is the case for WINSOCK *.h files,
# for instance.
#
# The interface for CheckIncludeFiles is more awkward.  Don't use it
# unless you really need it.  In particular, you will likely scratch
# your head about how exactly to specify a list of *.h files, so that
# CheckIncludeFiles actually takes it.

INCLUDE(CheckIncludeFile)
INCLUDE(CheckIncludeFiles)

# When you want to know if a specific function is available on your
# system, CheckFunctionExists is the module that people are likely to
# think of.  However, some "functions" are implemented as macros!
# CheckFunctionExists won't handle that.  CheckSymbolExists will.

INCLUDE(CheckSymbolExists)


####################################################################
#  DART DASHBOARD                                                  #
####################################################################

# CMake is integrated with a testing program called CTest.  It can
# create so-called "Dart Dashboards" on external websites.  These
# list the number of warnings and errors in a build.  If you write
# unit tests, the dashboard will list whether those tests pass or
# fail.  Information about your build can be dumped nightly, 
# continuously, or "experimentally" i.e. at any time you feel like.
#
# Chicken does not yet take full advantage of Dart Dashboard
# capabilities.  It is here as proof-of-concept.  This 1 line of
# code was sufficient to allow build results to be posted on the
# default Kitware public dashboard.  Over time, unit tests will be
# implemented and a canonical Dashboard of Chicken's status will
# be specified.

INCLUDE(Dart)


####################################################################
#  MACROS                                                          #
####################################################################

# CMake macros save work.  They are best employed:
#
# - to wrap up tasks that occur over and over again, i.e. as a
#   kind of function or subroutine.
#
# - to localize build rules in subdirectories, i.e. so you don't
#   have to type ${CMAKE_CURRENT_BINARY_DIR} all the time.
#
# CMake macros are also a way to obfuscate your code, make it
# unmaintainable, and render it illegible to others.  Don't get
# macro happy!  Programmers often think that abstraction and
# gratuitous refactoring is their job.  But, it's not the job of
# a Build Engineer.  Above all else, a Build Engineer needs to 
# Keep It Simple Stupid so that other people can understand,
# maintain, and spot problems with the build.
#
# This is why dumb lists of needed *.c files are often preferred to
# fancy build rules and macro wrap-ups.  It's easy for a programmer
# who doesn't know CMake to look through a simple list and spot files
# that need to be added, changed, or deleted.  They can use text
# editor search tools on such lists; they can't find weird production
# rules that do magical things to input strings.
#
# Prefer the straightforward CMake way to specify things, even if it
# is longer.   Some day, you're going to be asking someone on the CMake
# mailing list, "What's wrong with my code?"  If it's straightforward
# CMake code, you'll get snappy answers.  If you've wrapped it in 3
# bazillion layers of macros, nobody's going to be able to help you.  If
# you want someone to join your open source project as a build engineer,
# and they have to spend forever just figuring out how you
# macrotized everything, they're not going to bother.


####################################################################
#  TEXT UTILITIES                                                  #
####################################################################

# The text utilities evolved because handling lists properly in
# CMake can get confusing.  A list in CMake is a string of elements
# separated by semicolons.  So when is it a string, and when is it
# a list?  ${mylist} and "${mylist}" will give you completely different
# results; the quotes work as a sort of evaluator.
#
# Currently I am too lazy to explain all the nuances.
#
# Once you've figured out how to process your lists and strings properly,
# it is best to wrap up what you did and use it forever.  Otherwise you
# will make lotsa trivial mistakes over and over again.  I use FOREACH to

=== boot/CMakeLists.txt ===
# Copyright (c) 2006 by Brandon J. Van Every under MIT-style license.
# See LICENSE section at end of file for full license text.

####################################################################
#  MINIMAL BUILD                                                   #
####################################################################

# Files built here are only used for the bootstrap.  They are never installed.
# Consequently, we don't need to build everything.  We only build static
# libraries and executables, no need to fool with anything more complicated.
# We build:
#  libchicken-boot
#  chicken-boot
#
# chicken-boot is then used by the rest of the build.


####################################################################
#  CHICKEN_CONFIG_H                                                #
####################################################################

CONFIGURE_FILE(${Chicken_SOURCE_DIR}/chicken-config-cmake.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/chicken-config.h)


####################################################################
#  CHICKEN_DEFAULTS_H                                              #
####################################################################

# ./configure does the substitutions at make time, not
# configuration time.  Will this cause problems if
# people are using both builds?
CONFIGURE_FILE(${Chicken_SOURCE_DIR}/chicken-defaults.h.in
  ${CMAKE_CURRENT_BINARY_DIR}/chicken-defaults.h)


####################################################################
#  .C GENERATION                                                   #
####################################################################

# ./configure just plops chicken-config.h in the source tree.
# Try to avoid collisions with it by searching 
# ${CMAKE_CURRENT_BINARY_DIR} first.

INCLUDE_DIRECTORIES(BEFORE ${CMAKE_CURRENT_BINARY_DIR})

# Do not use LIBRARY_SCM_TO_C_EXPORTS to build the bootstrap compiler.
# We don't need the exports to build the next compiler stage, and
# Chicken 2.3 doesn't generate them.
# If EXTANT_CHICKEN is a high enough version number to generate .exports,
# we'll have stray .exports junk in the directory.  Do we care about
# cleaning it up?

IF(HAVE_BOOT_CFILES)
  # We will simply copy boot/cfiles/*.c files
  FOREACH(f ${BOOT_CFILES})
    ADD_CUSTOM_COMMAND(
      OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/${f}
      MAIN_DEPENDENCY ${Chicken_SOURCE_DIR}/boot/cfiles/${f}
      COMMAND ${CMAKE_COMMAND} -E copy_if_different "${Chicken_SOURCE_DIR}/boot/cfiles/${f}" "${CMAKE_CURRENT_BINARY_DIR}/${f}"
      COMMENT "Copying ${Chicken_SOURCE_DIR}/boot/cfiles/${f} to ${CMAKE_CURRENT_BINARY_DIR}/${f}"
    )
  ENDFOREACH(f)

ELSE(HAVE_BOOT_CFILES)
  # We will generate the .c files using the available Chicken compiler.

  # files for libchicken
  LIBRARY_SCM_TO_C(eval)
  LIBRARY_SCM_TO_C(extras)
  LIBRARY_SCM_TO_C(library build)
  LIBRARY_SCM_TO_C(lolevel)
  LIBRARY_SCM_TO_C(match)
  SIMPLE_SCM_TO_C(optimizer tweaks)
  LIBRARY_SCM_TO_C(pcre regex-common)
  LIBRARY_SCM_TO_C(posixunix)
  LIBRARY_SCM_TO_C(posixwin)
  LIBRARY_SCM_TO_C(pregexp regex-common)
  LIBRARY_SCM_TO_C(profiler)
  LIBRARY_SCM_TO_C(regexunix regex-common)
  LIBRARY_SCM_TO_C(scheduler)
  LIBRARY_SCM_TO_C(srfi-1)
  LIBRARY_SCM_TO_C(srfi-4)
  LIBRARY_SCM_TO_C(srfi-13)
  LIBRARY_SCM_TO_C(srfi-14)
  LIBRARY_SCM_TO_C(srfi-18)
  LIBRARY_SCM_TO_C(stub)
  SIMPLE_SCM_TO_C(support banner tweaks)
  LIBRARY_SCM_TO_C(tcp)
  LIBRARY_SCM_TO_C(utils)

  # files for chicken
  SIMPLE_SCM_TO_C(batch-driver tweaks)
  SIMPLE_SCM_TO_C(c-backend tweaks)
  SIMPLE_SCM_TO_C(c-platform tweaks)
  SIMPLE_SCM_TO_C(chicken build chicken-ffi-macros chicken-more-macros tweaks)
  SIMPLE_SCM_TO_C(compiler tweaks)

ENDIF(HAVE_BOOT_CFILES)


####################################################################
#  CREATE LIBCHICKEN-BOOT                                          #
####################################################################

GET_LIBCHICKEN_C_SOURCES(LIBCHICKEN_BOOT_SOURCES)
ADD_CUSTOM_TARGET(libchicken-boot-c DEPENDS ${LIBCHICKEN_BOOT_SOURCES})

ADD_LIBRARY(libchicken-boot STATIC ${LIBCHICKEN_BOOT_SOURCES})
SET_TARGET_PROPERTIES(libchicken-boot PROPERTIES
  COMPILE_FLAGS "-DC_BUILDING_LIBCHICKEN ${STATIC_FLAGS}"
  OUTPUT_NAME chicken-boot)
IF(WIN32 AND NOT CMAKE_COMPILER_IS_GNUCC)
  SET_TARGET_PROPERTIES(libchicken-boot PROPERTIES PREFIX "lib")
ENDIF(WIN32 AND NOT CMAKE_COMPILER_IS_GNUCC)
TARGET_LINK_LIBRARIES(libchicken-boot ${MORE_STATIC_LIBS})
ADD_DEPENDENCIES(libchicken-boot libchicken-boot-c)


####################################################################
#  CREATE CHICKEN-BOOT                                             #
####################################################################

GET_CHICKEN_C_SOURCES(CHICKEN_BOOT_SOURCES)
ADD_CUSTOM_TARGET(chicken-boot-c DEPENDS ${CHICKEN_BOOT_SOURCES})

ADD_EXECUTABLE(chicken-boot ${CHICKEN_BOOT_SOURCES})
SET_TARGET_PROPERTIES(chicken-boot PROPERTIES COMPILE_FLAGS "${STATIC_FLAGS}")
TARGET_LINK_LIBRARIES(chicken-boot libchicken-boot)
ADD_DEPENDENCIES(chicken-boot chicken-boot-c)


####################################################################
#   LICENSE                                                        #
####################################################################

# Copyright (c) 2006 by Brandon J. Van Every
# 
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the "Software"),
# to deal in the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
# IN THE SOFTWARE.

=== static/CMakeLists.txt ===
# Copyright (c) 2006 by Brandon J. Van Every under MIT-style license.
# See LICENSE section at end of file for full license text.


####################################################################
#  LIBRARY COLLISION BUG                                           #
####################################################################

# CMake 2.4.3 has a bug where shared and static libraries in the same
# directory clobber each other if they have the same rootname.  Also,
# if static and shared libraries are in the same directory, static
# exes will prefer to link with the shared libraries.  To work around
# these problems, we build all static libs and exes in a subdirectory.

# The .c files we need are actually in a parent directory.
# Fortunately, we've already specified
#
#   CHICKEN_LIB_SOURCES
#   CHICKEN_UNSAFE_LIB_SOURCES
#   CSI_EXE_SOURCES
#   CHICKEN_EXE_SOURCES
#
# at the correct locations for fully qualifying the names of the
# .c files.  This makes target generation pretty easy.
#
# Doing static library generation in a subdirectory allows us to
# avoid pain at installation time.  Previously, I had solved the
# problem on MinGW by postfixing -s to the static library name, then
# copying the library to the correct name at install time.  This
# works fine when you know what your library suffixes are supposed
# to be, but it becomes a real PITA when you're dealing with unknown
# OSes that you can't test.  It's simpler to avoid the collision
# problem, build in separate namespaces, and not have to do anything
# special at INSTALL time.


####################################################################
#  CREATE LIBCHICKEN                                               #
####################################################################

# When in a subdirectory, CMake won't pick up that our
# .c files are generated.  So we fudge around it; note that
# GET_LIB_CSOURCE files are part of these files and they're not generated.
# Also there are duplicate files in the list; hope
# that doesn't cause problems.  But if it works, close enough.

SET_SOURCE_FILES_PROPERTIES(
  ${CHICKEN_LIB_SOURCES}
  ${CHICKEN_UNSAFE_LIB_SOURCES}
  ${CSI_EXE_SOURCES}
  ${CHICKEN_EXE_SOURCES}
  PROPERTIES GENERATED true
)

IF(MSVC)

  # Eventually, we wish to support different postfixes for debug, release builds etc.
  # For now, the user has to install the 1 configuration she actually wants.

  ADD_LIBRARY(libchicken-static STATIC ${CHICKEN_LIB_SOURCES})
  SET_TARGET_PROPERTIES(libchicken-static PROPERTIES
    COMPILE_FLAGS "-DC_BUILDING_LIBCHICKEN ${STATIC_FLAGS}"
    OUTPUT_NAME "chicken" PREFIX "lib"
    RELEASE_POSTFIX "-s" MINSIZEREL_POSTFIX "-s" DEBUG_POSTFIX "-s" RELWITHDEBINFO_POSTFIX "-s")
  TARGET_LINK_LIBRARIES(libchicken-static ${MORE_STATIC_LIBS})
  ADD_DEPENDENCIES(libchicken-static libchicken-c)

  ADD_LIBRARY(libuchicken-static STATIC ${CHICKEN_UNSAFE_LIB_SOURCES})
  SET_TARGET_PROPERTIES(libuchicken-static PROPERTIES
    COMPILE_FLAGS "-DC_BUILDING_LIBCHICKEN -DC_UNSAFE_RUNTIME ${STATIC_FLAGS}"
    OUTPUT_NAME "uchicken" PREFIX "lib"
    RELEASE_POSTFIX "-s" MINSIZEREL_POSTFIX "-s" DEBUG_POSTFIX "-s" RELWITHDEBINFO_POSTFIX "-s")
  TARGET_LINK_LIBRARIES(libuchicken-static ${MORE_STATIC_LIBS})
  ADD_DEPENDENCIES(libuchicken-static libuchicken-c)

  ADD_LIBRARY(libchickengui-static STATIC ${CHICKEN_LIB_SOURCES})
  SET_TARGET_PROPERTIES(libchickengui-static PROPERTIES
    COMPILE_FLAGS "-DC_BUILDING_LIBCHICKEN -DC_WINDOWS_GUI ${STATIC_FLAGS}"
    OUTPUT_NAME "chickengui" PREFIX "lib"
    RELEASE_POSTFIX "-s" MINSIZEREL_POSTFIX "-s" DEBUG_POSTFIX "-s" RELWITHDEBINFO_POSTFIX "-s")
  TARGET_LINK_LIBRARIES(libchickengui-static ${GUI_LIBS} ${MORE_STATIC_LIBS})
  ADD_DEPENDENCIES(libchickengui-static libchicken-c)

ELSE(MSVC)

  ADD_LIBRARY(libchicken-static STATIC ${CHICKEN_LIB_SOURCES})
  SET_TARGET_PROPERTIES(libchicken-static PROPERTIES
    COMPILE_FLAGS "-DC_BUILDING_LIBCHICKEN ${STATIC_FLAGS}"
    OUTPUT_NAME "chicken")
  TARGET_LINK_LIBRARIES(libchicken-static ${MORE_STATIC_LIBS})
  ADD_DEPENDENCIES(libchicken-static libchicken-c)

  ADD_LIBRARY(libuchicken-static STATIC ${CHICKEN_UNSAFE_LIB_SOURCES})
  SET_TARGET_PROPERTIES(libuchicken-static PROPERTIES
    COMPILE_FLAGS "-DC_BUILDING_LIBCHICKEN -DC_UNSAFE_RUNTIME ${STATIC_FLAGS}"
    OUTPUT_NAME "uchicken")
  TARGET_LINK_LIBRARIES(libuchicken-static ${MORE_STATIC_LIBS})
  ADD_DEPENDENCIES(libuchicken-static libuchicken-c)

  IF(WIN32 AND NOT CYGWIN)
    ADD_LIBRARY(libchickengui-static STATIC ${CHICKEN_LIB_SOURCES})
    SET_TARGET_PROPERTIES(libchickengui-static PROPERTIES
      COMPILE_FLAGS "-DC_BUILDING_LIBCHICKEN -DC_WINDOWS_GUI ${STATIC_FLAGS}"
      OUTPUT_NAME "chickengui")
    TARGET_LINK_LIBRARIES(libchickengui-static ${GUI_LIBS} ${MORE_STATIC_LIBS})
    ADD_DEPENDENCIES(libchickengui-static libchicken-c)
  ENDIF(WIN32 AND NOT CYGWIN)

ENDIF(MSVC)


####################################################################
#  CREATE CSI-STATIC                                               #
####################################################################

ADD_EXECUTABLE(csi-static ${CSI_EXE_SOURCES})
SET_TARGET_PROPERTIES(csi-static PROPERTIES COMPILE_FLAGS "${STATIC_FLAGS}")
TARGET_LINK_LIBRARIES(csi-static libchicken-static)
ADD_DEPENDENCIES(csi-static csi-c)


####################################################################
#  CREATE CHICKEN-STATIC.EXE                                       #
####################################################################

ADD_EXECUTABLE(chicken-static ${CHICKEN_EXE_SOURCES})
SET_TARGET_PROPERTIES(chicken-static PROPERTIES COMPILE_FLAGS "${STATIC_FLAGS}")
TARGET_LINK_LIBRARIES(chicken-static libchicken-static)
ADD_DEPENDENCIES(chicken-static chicken-c)


####################################################################
#  INSTALLATION                                                    #
####################################################################

INSTALL(TARGETS
  chicken-static
  csi-static
  libchicken-static
  libuchicken-static
  RUNTIME DESTINATION ${BIN_HOME}
  LIBRARY DESTINATION ${LIB_HOME}
  ARCHIVE DESTINATION ${LIB_HOME}
)
IF(WIN32 AND NOT CYGWIN)
  INSTALL(TARGETS
    libchickengui-static
    RUNTIME DESTINATION ${BIN_HOME}
    LIBRARY DESTINATION ${LIB_HOME}
    ARCHIVE DESTINATION ${LIB_HOME}
  )
ENDIF(WIN32 AND NOT CYGWIN)


####################################################################
#   LICENSE                                                        #
####################################################################

# Copyright (c) 2006 by Brandon J. Van Every
# 
# Permission is hereby granted, free of charge, to any person obtaining
# a copy of this software and associated documentation files (the "Software"),
# to deal in the Software without restriction, including without limitation
# the rights to use, copy, modify, merge, publish, distribute, sublicense,
# and/or sell copies of the Software, and to permit persons to whom the
# Software is furnished to do so, subject to the following conditions:
#
# The above copyright notice and this permission notice shall be included in
# all copies or substantial portions of the Software.
# 
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
# FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS
# IN THE SOFTWARE.

## chicken 3.2.7

=== Makefile ===
# Makefile - toplevel makefile
#
# Copyright (c) 2007, Felix L. Winkelmann
# Copyright (c) 2008, The Chicken Team
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following
# conditions are met:
#
#   Redistributions of source code must retain the above copyright notice, this list of conditions and the following
#     disclaimer. 
#   Redistributions in binary form must reproduce the above copyright notice, this list of conditions and the following
#     disclaimer in the documentation and/or other materials provided with the distribution. 
#   Neither the name of the author nor the names of its contributors may be used to endorse or promote
#     products derived from this software without specific prior written permission. 
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS
# OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY
# AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDERS OR
# CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.


.PHONY: all clean distclean spotless install uninstall confclean check dist \
	libs install-libs fullcheck bootstrap

ifndef PLATFORM
all clean spotless distclean install uninstall:
	@echo "no PLATFORM given."
	@echo ""
	@echo "Please select your target platform by running one of the following commands:"
	@echo ""
	@echo "  $(MAKE) PLATFORM=linux"
	@echo "  $(MAKE) PLATFORM=bsd"
	@echo "  $(MAKE) PLATFORM=macosx"
	@echo "  $(MAKE) PLATFORM=mingw-msys"
	@echo "  $(MAKE) PLATFORM=mingw"
	@echo "  $(MAKE) PLATFORM=cygwin"
	@echo "  $(MAKE) PLATFORM=solaris"
	@echo "  $(MAKE) PLATFORM=cross-linux-mingw"
	@echo "  $(MAKE) PLATFORM=msvc"
	@echo ""
	@echo "For more information, consult the README file."
	@exit 1
else
all:
	$(MAKE) -f Makefile.$(PLATFORM) all
clean:
	$(MAKE) -f Makefile.$(PLATFORM) clean
distclean:
	$(MAKE) -f Makefile.$(PLATFORM) distclean
spotless:
	$(MAKE) -f Makefile.$(PLATFORM) spotless
install:
	$(MAKE) -f Makefile.$(PLATFORM) install
uninstall:
	$(MAKE) -f Makefile.$(PLATFORM) uninstall
confclean:
	$(MAKE) -f Makefile.$(PLATFORM) confclean
check:
	$(MAKE) -f Makefile.$(PLATFORM) check
fullcheck:
	$(MAKE) -f Makefile.$(PLATFORM) fullcheck
dist:
	$(MAKE) -f Makefile.$(PLATFORM) distfiles
	csi -s scripts/makedist.scm
libs:
	$(MAKE) -f Makefile.$(PLATFORM) libs
install-libs:
	$(MAKE) -f Makefile.$(PLATFORM) install-libs
bootstrap:
	$(MAKE) -f Makefile.$(PLATFORM) bootstrap
endif

## chicken 3.4.0

=== Makefile ===
--- 
+++ 
@@ -24,12 +24,16 @@
 # OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 # POSSIBILITY OF SUCH DAMAGE.
 
+STANDARD_TARGETS \
+	= all clean distclean spotless install uninstall confclean check \
+	  fullcheck dist libs install-libs bootstrap
 
-.PHONY: all clean distclean spotless install uninstall confclean check dist \
-	libs install-libs fullcheck bootstrap
+SRCDIR = .
+
+.PHONY: $(STANDARD_TARGETS)
 
 ifndef PLATFORM
-all clean spotless distclean install uninstall:
+$(STANDARD_TARGETS):
 	@echo "no PLATFORM given."
 	@echo ""
 	@echo "Please select your target platform by running one of the following commands:"
@@ -46,32 +50,34 @@
 	@echo ""
 	@echo "For more information, consult the README file."
 	@exit 1
+dist:
+	csi -s scripts/makedist.scm
 else
 all:
-	$(MAKE) -f Makefile.$(PLATFORM) all
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) all
 clean:
-	$(MAKE) -f Makefile.$(PLATFORM) clean
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) clean
 distclean:
-	$(MAKE) -f Makefile.$(PLATFORM) distclean
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) distclean
 spotless:
-	$(MAKE) -f Makefile.$(PLATFORM) spotless
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) spotless
 install:
-	$(MAKE) -f Makefile.$(PLATFORM) install
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) install
 uninstall:
-	$(MAKE) -f Makefile.$(PLATFORM) uninstall
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) uninstall
 confclean:
-	$(MAKE) -f Makefile.$(PLATFORM) confclean
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) confclean
 check:
-	$(MAKE) -f Makefile.$(PLATFORM) check
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) check
 fullcheck:
-	$(MAKE) -f Makefile.$(PLATFORM) fullcheck
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) fullcheck
 dist:
-	$(MAKE) -f Makefile.$(PLATFORM) distfiles
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) distfiles
 	csi -s scripts/makedist.scm
 libs:
-	$(MAKE) -f Makefile.$(PLATFORM) libs
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) libs
 install-libs:
-	$(MAKE) -f Makefile.$(PLATFORM) install-libs
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) install-libs
 bootstrap:
-	$(MAKE) -f Makefile.$(PLATFORM) bootstrap
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) bootstrap
 endif

=== benchmarks/others/Makefile ===
.PHONY: all clean

all: exception except setlongjmp except-fast except2

clean: 
	rm -f *.o except exception except-fast except2 setlongjmp

exception: exception.cpp
	g++ $< -o $@ -O2

except: except.scm
	csc $< -o $@ -O2 -d0

except-fast: except.scm
	csc $< -o $@ -Ob

except2: except2.scm
	csc $< -o $@ -Ob

setlongjmp: setlongjmp.c
	gcc $< -o $@ -O2

## chicken 4.2.0

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # Makefile - toplevel makefile
 #
 # Copyright (c) 2007, Felix L. Winkelmann
-# Copyright (c) 2008, The Chicken Team
+# Copyright (c) 2008-2009, The Chicken Team
 # All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following
@@ -46,12 +46,9 @@
 	@echo "  $(MAKE) PLATFORM=cygwin"
 	@echo "  $(MAKE) PLATFORM=solaris"
 	@echo "  $(MAKE) PLATFORM=cross-linux-mingw"
-	@echo "  $(MAKE) PLATFORM=msvc"
 	@echo ""
 	@echo "For more information, consult the README file."
 	@exit 1
-dist:
-	csi -s scripts/makedist.scm
 else
 all:
 	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) all
@@ -80,4 +77,6 @@
 	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) install-libs
 bootstrap:
 	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) bootstrap
+bench:
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) bench
 endif

## chicken 4.5.0

=== Makefile ===
--- 
+++ 
@@ -1,7 +1,7 @@
 # Makefile - toplevel makefile
 #
+# Copyright (c) 2008-2010, The Chicken Team
 # Copyright (c) 2007, Felix L. Winkelmann
-# Copyright (c) 2008-2009, The Chicken Team
 # All rights reserved.
 #
 # Redistribution and use in source and binary forms, with or without modification, are permitted provided that the following
@@ -24,9 +24,18 @@
 # OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 # POSSIBILITY OF SUCH DAMAGE.
 
+
+ifeq ($(CONFIG)$(PLATFORM),)
+CONFIG=config.make
+endif
+
+ifneq ($(CONFIG),)
+include $(CONFIG)
+endif
+
 STANDARD_TARGETS \
 	= all clean distclean spotless install uninstall confclean check \
-	  fullcheck dist libs install-libs bootstrap
+	  fullcheck dist libs
 
 SRCDIR = .
 
@@ -51,32 +60,26 @@
 	@exit 1
 else
 all:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) all
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) CONFIG=$(CONFIG) all
 clean:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) clean
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) CONFIG=$(CONFIG) clean
 distclean:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) distclean
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) CONFIG=$(CONFIG) distclean
 spotless:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) spotless
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) CONFIG=$(CONFIG) spotless
 install:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) install
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) CONFIG=$(CONFIG) install
 uninstall:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) uninstall
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) CONFIG=$(CONFIG) uninstall
 confclean:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) confclean
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) CONFIG=$(CONFIG) confclean
 check:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) check
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) CONFIG=$(CONFIG) check
 fullcheck:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) fullcheck
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) CONFIG=$(CONFIG) fullcheck
 dist:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) distfiles
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) CONFIG=$(CONFIG) distfiles
 	csi -s scripts/makedist.scm
 libs:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) libs
-install-libs:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) install-libs
-bootstrap:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) bootstrap
-bench:
-	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) bench
+	$(MAKE) -f $(SRCDIR)/Makefile.$(PLATFORM) CONFIG=$(CONFIG) libs
 endif

=== debian/changelog ===
chicken (4.5.0-1) unstable; urgency=low

  * New upstream version.

 -- Davide Puricelli (evo) <evo@debian.org>  Thu, 17 Jun 2010 15:06:15 +0200

chicken (4.4.6-1) unstable; urgency=high

  * New upstream version.
  * Extensions are back in their proper location; closes: #576815.

 -- Davide Puricelli (evo) <evo@debian.org>  Fri, 16 Apr 2010 13:35:43 +0200

chicken (4.4.0-1) unstable; urgency=low

  * New upstream version.
  * Now shipping libchicken5 instead of libchicken4.

 -- Davide Puricelli (evo) <evo@debian.org>  Sat, 27 Mar 2010 13:24:39 +0100

chicken (4.2.0-1) unstable; urgency=low

  * New upstream version; closes: #539841, #548962.
  * Fixed build process on Debian GNU/Hurd; closes: #532895.
  * Now shipping libchicken4 instead of libchicken3. 

 -- Davide Puricelli (evo) <evo@debian.org>  Fri, 30 Oct 2009 18:37:39 +0100

chicken (3.4.0-1) unstable; urgency=low

  * New upstream version.
  * Bumped Standards-Version to release 3.8.1.0.
  * CFLAGS are now set in the right way.
  * Shipping HTML manual with doc-base.

 -- Davide Puricelli (evo) <evo@debian.org>  Fri, 03 Apr 2009 17:22:25 +0200

chicken (3.2.7-2) unstable; urgency=high

  * debian/rules: added chrpath support to remove RPATH pointing to
    insecure location; closes: #495753.
  * debian/control: added chrpath to Build-Depends. 

 -- Davide Puricelli (evo) <evo@debian.org>  Thu, 21 Aug 2008 11:24:11 +0200

chicken (3.2.7-1) unstable; urgency=high

  * Acknowledge NMU, thanks Ivan for all your work.
  * New upstream version; closes: #418747, #426095, #426094.
  * Fixed Build-Depends; closes: #479182.
  * Added /var/lib/chicken/3 directory; closes: #418738.

 -- Davide Puricelli (evo) <evo@debian.org>  Sat, 05 Jul 2008 09:14:18 +0200

chicken (3.2.7-0.1) unstable; urgency=high

  * Non-maintainer upload
  * New upstream version

 -- Ivan Raikov <raikov@oist.jp>  Tue, 10 Jun 2008 04:20:00 -1100

chicken (2.5-1) unstable; urgency=low

  * New upstream version; closes: #388632.
  * Installing eggs into /var/lib/chicken, not /usr/lib/chicken.
    closes: #388644.

 -- Davide Puricelli (evo) <evo@debian.org>  Sun,  7 Jan 2007 17:13:09 +0100

chicken (2.3-1) unstable; urgency=medium

  * New upstream version.
  * Fixed nursery size test to let chicken build on ia64 and alpha, too;
    closes: #356996.

 -- Davide Puricelli (evo) <evo@debian.org>  Sun, 23 Apr 2006 12:28:15 +0200

chicken (2.2-1) unstable; urgency=high

  * New upstream version; closes: #282956.
  * Repackaged from scratch:
   - removed chicken and chicken-dev packages.
   - three new packages, see README.Debian for details.
   closes: #270827, #339028. 
  * Added /usr/lib/chicken directory to support external eggs;
    closes: #337392, #277866.
  * Added support for ppc64 architecture, closes: #322444.
  * libchicken-dev now depends on libpcre3-dev, closes: #276981.
  * Fixed a wrong path into chicken manpage, closes: #328193.

 -- Davide Puricelli (evo) <evo@debian.org>  Tue, 14 Feb 2006 21:56:39 +0100

chicken (1.63-2) unstable; urgency=high

  * Fixed issues with doc-base; closes: #267152, #267148, #267218.

 -- Davide Puricelli (evo) <evo@debian.org>  Sat, 21 Aug 2004 11:12:18 +0200

chicken (1.63-1) unstable; urgency=high

  * New upstream version; closes: #247517, #227115.
  * Acknowledge NMU, thanks Tollef; closes: #260392, #249340.
  * Enhanced description; closes: #209441, #251210.
  * Executed libtoolize before build process; closes: #263089.
  * Removed useless manpages; closes: #259452.
  * Added chicken-setup script; closes: #248558.

 -- Davide Puricelli (evo) <evo@debian.org>  Fri, 20 Aug 2004 18:46:00 +0200

chicken (1.22-1.1) unstable; urgency=low

  * NMU
  * Add amd64 support (closes: #249340)

 -- Tollef Fog Heen <tfheen@debian.org>  Tue, 20 Jul 2004 11:28:05 +0200

chicken (1.22-1) unstable; urgency=low

  * New upstream version.

 -- Davide Puricelli (evo) <evo@debian.org>  Mon, 19 Jan 2004 18:41:54 +0100

chicken (1.17-2) unstable; urgency=medium

  * Applied patch suggested by Matthias Klose to fix build failures
    on m68k, mips and mipsel, closes: #208932.

 -- Davide Puricelli (evo) <evo@debian.org>  Sat,  6 Sep 2003 14:19:00 +0200

chicken (1.17-1) unstable; urgency=low

  * New upstream version, closes: #199560.

 -- Davide Puricelli (evo) <evo@debian.org>  Sat,  6 Sep 2003 11:51:39 +0200

chicken (1.10-2) unstable; urgency=high

  * Running libtoolize before build process should fix all those
    horrible build failures on archs != i386.

 -- Davide Puricelli (evo) <evo@debian.org>  Sun,  8 Jun 2003 12:17:29 +0200

chicken (1.10-1) unstable; urgency=low

  * New upstream version.
  * debian/control: fixed a spelling error, closes: #195119.
  * chicken.doc-base: it's "manual.html", not "index.html", thanks Laurent.
    closes: #189742.

 -- Davide Puricelli (evo) <evo@debian.org>  Sat,  7 Jun 2003 12:08:59 +0200

chicken (1.0-1) unstable; urgency=low

  * New upstream version.
  * Documentation is now installed with install-docs; closes: #181542.

 -- Davide Puricelli (evo) <evo@debian.org>  Sat, 12 Apr 2003 15:42:22 +0200

chicken (0.1082-1) unstable; urgency=low

  * New upstream version.
  * Removing hacks for hppa and arm, now gcc 3.2 is the default compiler
    on all the archs, so we shouldn't need them anymore.

 -- Davide Puricelli (evo) <evo@debian.org>  Fri, 14 Feb 2003 14:47:38 +0100

chicken (0.1072-2) unstable; urgency=low

  * Removing useless hack for mips and mipsel; we need gcc-3.2, so we 
    just have to wait.
  * Moving /usr/include/* to chicken package; closes: #157841.

 -- Davide Puricelli (evo) <evo@debian.org>  Thu, 12 Sep 2002 13:11:22 +0200

chicken (0.1072-1) unstable; urgency=low

  * New upstream version.
  * Added highlevel-macros.scm, moremacros.scm and chicken.init;
    closes: #156700.
  * hppa, mips and mipsel need -ffunction-sections to build;
    closes: #150901.

 -- Davide Puricelli (evo) <evo@debian.org>  Sat, 17 Aug 2002 12:16:36 +0200

chicken (0.1071-1) unstable; urgency=low



=== debian/control ===
Source: chicken
Homepage: http://www.call-with-current-continuation.org/
Section: interpreters
Priority: optional
Maintainer: Davide Puricelli (evo) <evo@debian.org>
Build-Depends: debhelper (>> 5.0.0), libpcre3-dev, texinfo, chrpath
Standards-Version: 3.8.4.0

Package: chicken-bin
Section: lisp
Architecture: any
Conflicts: chicken, chicken-dev
Depends: ${shlibs:Depends}, ${misc:Depends}, libchicken-dev (= ${binary:Version})
Replaces: chicken, chicken-dev
Description: A practical and portable Scheme system - compiler
 CHICKEN is a Scheme compiler which compiles a subset of R5RS into C.
 It uses the ideas presented in Baker's paper "Cheney on the MTA", and
 has a small core and is easily extendable.
 .
 This package contains the compiler.
 

Package: libchicken5
Architecture: any
Section: libs
Priority: optional
Replaces: chicken, chicken-dev, libchicken0, libchicken3, libchicken4
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: chicken, chicken-dev, libchicken0, libchicken3, libchicken4
Description: A practical and portable Scheme system - runtime
 CHICKEN is a Scheme compiler which compiles a subset of R5RS into C. 
 It uses the ideas presented in Baker's paper "Cheney on the MTA", and 
 has a small core and is easily extendable.
 .
 This package contains the shared library needed to run programs using
 chicken.
 

Package: libchicken-dev
Architecture: any
Section: libdevel
Priority: optional
Conflicts: chicken, chicken-dev
Depends: libchicken5 (= ${binary:Version}), libpcre3-dev, ${misc:Depends}
Replaces: chicken, chicken-dev
Description: A practical and portable Scheme system - development
 CHICKEN is a Scheme compiler which compiles a subset of R5RS into C.
 It uses the ideas presented in Baker's paper "Cheney on the MTA", and
 has a small core and is easily extendable.
 .
 This package contains the header file and static library for developing
 with chicken.

=== debian/rules ===
#!/usr/bin/make -f
BUILD_ARCH = $(shell dpkg --print-installation-architecture)

CFLAGS= -g
ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
     CFLAGS += -O0
        else
     CFLAGS += -O2
endif

MAKE:=$(MAKE) PLATFORM=linux
PREFIX=/usr
BINARYVERSION=5

build: build-stamp
build-stamp:
	dh_testdir
	$(MAKE) PREFIX=$(PREFIX) C_COMPILER_OPTIMIZATION_OPTIONS="$(CFLAGS)" 
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp
	$(MAKE) clean
	$(MAKE) distclean
	rm -f c_defaults.h chicken_defaults.h lib*.so chicken.info-*		
	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs
# The directories here have to be prefixed by $(CURDIR)/debian/tmp
# because that is the location where the binary package files are
# placed by dpkg-buildpackage. If absolute files are specified,
# i.e. /var/lib/chicken, then those files will be installed on the
# build system, but will not end up in the package.
	$(MAKE) PREFIX="$(CURDIR)/debian/tmp/usr" VARDIR="$(CURDIR)/debian/tmp/var/lib" install
	chrpath -d $(CURDIR)/debian/tmp/usr/bin/*
	chrpath -d $(CURDIR)/debian/tmp/var/lib/chicken/5/*.so

binary-common:
	dh_testdir
	dh_testroot
	dh_installdocs
	dh_installman
# The asterisk in chicken.info* is necessary, because Debian makeinfo
# is very different from the standard makeinfo, and it is incredibly
# difficult to convince it to produce standalone Texinfo files. 
#	dh_installinfo chicken.info*
	dh_installchangelogs ChangeLog.*
	dh_install --sourcedir=debian/tmp
	dh_link
ifeq "$(findstring nostrip,$(DEB_BUILD_OPTIONS))" ""
	dh_strip
endif	
	dh_compress
	dh_fixperms
	dh_makeshlibs -V
	dh_installdeb
	dh_shlibdeps -l debian/libchicken5/usr/lib
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary-indep: build install

binary-arch: build install
	$(MAKE) -f debian/rules DH_OPTIONS=-a binary-common

binary-%: build install
	make -f debian/rules binary-common DH_OPTIONS=-p$*

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install
